/* Program name --- lbs.c  2002.9.29 */

#include        <stdio.h>
#include        <string.h>
#include        <stdlib.h>
#include        <math.h>
#include        "approxdp.h"
#include        "lbs.h"

#define     DBG          0

float segdist();

float   lbs(lbsd1, lbsd2, warpd, lbs_buffer, calc, thdist)
struct  LbsData  *lbsd1;
struct  LbsData  *lbsd2;
struct  WarpData  *warpd;
float   *lbs_buffer;
int     calc;
float   thdist;
{
  float   dist_cur, mm;
  int    len1, ll, num1, num2;
  float  *lbs_prev, *lbs_cur, *swap;
  int *ssp, *sep, *elms1, *elms2;
  int sp_cur, sp_prev, ep_cur, ep_prev;
  float *lower1, *upper1, *lower2, *upper2;
  int k, k2, km, k2m;

  elms1 = warpd->ed[calc].elms1;
  elms2 = warpd->ed[calc].elms2;
  ssp = warpd->seg_env[calc].begin;
  sep = warpd->seg_env[calc].end;
  
  lower1 = lbsd1->segd[calc].lower;
  upper1 = lbsd1->segd[calc].upper;
  lower2 = lbsd2->segd[calc].lower;
  upper2 = lbsd2->segd[calc].upper;

  num1 = lbsd1->segd[calc].segs;
  num2 = lbsd2->segd[calc].segs;

  lbs_prev = lbs_buffer;
  lbs_cur = lbs_buffer + num2;

  len1 = elms1[0];
  (len1 < elms2[0]) ? (ll=len1) : (ll=elms2[0]);
  lbs_prev[0] = segdist(lower1[0], upper1[0], lower2[0], upper2[0]) * ll;

  ep_cur = sep[0];  
  for (k2=1 ; k2<=ep_cur ; k2++){
    (len1 < elms2[k2]) ? (ll=len1) : (ll=elms2[k2]);
    dist_cur = segdist(lower1[0], upper1[0], lower2[k2], upper2[k2]) * ll;
    lbs_prev[k2] = dist_cur + lbs_prev[k2-1];
    if (thdist < lbs_prev[k2])
      break;
  }
  sp_prev = 0;
  ep_prev = k2 - 1;

  for (k=1 ; k < num1 ; k++){
    len1 = elms1[k];
    km = k - 1;
    sp_cur = ssp[k];
    if (sp_cur < sp_prev)
      sp_cur = sp_prev;
    ep_cur = sep[k];

    for (k2=sp_cur ; k2<=ep_cur ; k2++){
      k2m = k2 - 1;
      (len1 < elms2[k2]) ? (ll=len1) : (ll=elms2[k2]);
      dist_cur = segdist(lower1[k], upper1[k], lower2[k2], upper2[k2]) * ll;
      lbs_cur[k2] = INITIAL;

      if (k2 > sp_prev && ep_prev+1 >= k2)
	lbs_cur[k2] = lbs_prev[k2m] + dist_cur;
      if (k2 > sp_cur){
	mm = lbs_cur[k2m] + dist_cur;
	if (lbs_cur[k2] > mm)
	  lbs_cur[k2] = mm;
      }
      if (k2 <= ep_prev){
	mm = lbs_prev[k2] + dist_cur;
	if (lbs_cur[k2] > mm)
	  lbs_cur[k2] = mm;
      }
      else{
	if (thdist < lbs_cur[k2]){
	  if (k != num1 - 1){
	    k2++;
	    break;
	  }
	}
      }
    }
    ep_cur = k2 - 1;
    for (k2=sp_cur ; k2<=ep_cur ; k2++){
      if (thdist >= lbs_cur[k2]){
	sp_prev = k2;
	break;
      }
    }
    if (k2 > ep_cur)
      return lbs_cur[k2-1];
    for (k2=ep_cur ; k2>=sp_cur ; k2--){
      if (thdist >= lbs_cur[k2]){
	ep_prev = k2;
	break;
      }
    }
    if (k != num1-1 && ep_prev < ssp[k+1]-1)
      return lbs_cur[k2+1];
    swap = lbs_cur;
    lbs_cur = lbs_prev;
    lbs_prev = swap;
  }
  return lbs_prev[num2-1];
}

float segdist(lower1, upper1, lower2, upper2)
float lower1;
float upper1;
float lower2;
float upper2;
{
  float diff, dist=0;

  if (upper1 < lower2){
    diff = lower2 - upper1;
    dist = diff * diff;
  }
  else{
    if (upper2 < lower1){
      diff = lower1 - upper2;
      dist = diff * diff;
    }
  }
  return dist;
}

void    getelm(elms, length, segs)
int     *elms;
int     length;
int     segs;
{
  int i, k, m, m2;

  m = (int)ceil(length / (float)segs);
  m2 = length - (segs -  1) * m;
  for (i=0 ; i<segs-1 ; i++)
    elms[i] = m;
  elms[segs-1] = m2;
}

void    getpaa(code, lbsd, calc)
float   *code;
struct  LbsData  *lbsd;
int     calc;
{
  int i, j, m, p=0, segs, length;
  float min, max;

  length = lbsd->seq_length;
  segs = lbsd->segd[calc].segs;
  m = (int)ceil(length / (float)segs);

  p=0;
  for (i=0 ; i<segs ; i++){
    if (p+m > length)
      m = length - p;
    min = max = code[p];
    for (j=p+1 ; j<p+m ; j++){
      if (min > code[j])
	min = code[j];
      if (max < code[j])
	max = code[j];
    }
    lbsd->segd[calc].lower[i] = min;
    lbsd->segd[calc].upper[i] = max;
    p += m;
  }
}

int setcalcs(length)
int length;
{
  int k=1, p=C1, interval=INTERVAL, segs;

  segs = (int)ceil(length / (float)p);
  while(1){
    p *= interval;
    segs = (int)ceil(length / (float)p);
    if (segs >= MINSEGS)
      k++;
    else
      break;
  }
  if (k > CALCS){
    printf("Error: calcs=%d (%d)\n", k, CALCS);
    exit(1);
  }
  return k;
}

void setsegs(appsegs, length, calcs)
int *appsegs;
int length;
int calcs;
{
  int k, p=C1, interval=INTERVAL;

  appsegs[calcs-1] = (int)ceil(length / (float)p);
  for (k=calcs-2 ; k>=0 ; k--){
    p *= interval;
    appsegs[k] = (int)ceil(length / (float)p);
  }
}

void setsegenv(warpd, sp, ep, segs1, segs2, len1, len2, calc)
struct  WarpData  *warpd;
int     *sp;
int     *ep;
int     segs1;
int     segs2;
int     len1;
int     len2;
int     calc;
{
  int i, j;
  int xs, xe, ys, ye;
  int *ssp, *sep;
  int *elms1, *elms2;

  ssp = warpd->seg_env[calc].begin;
  sep = warpd->seg_env[calc].end;
  elms1 = warpd->ed[calc].elms1;
  elms2 = warpd->ed[calc].elms2;
  
  xs=0;
  xe=-1;
  for (i=0 ; i<segs1 ; i++){
    ys=-1;
    for (j=0 ; j<segs2 ; j++){
      ys += elms2[j];
      if (sp[xs] <= ys) 
	break;
    }
    ssp[i] = j;
    xs += elms1[i];

    xe += elms1[i];
    ye = len2;
    for (j=segs2 -1 ; j>=0 ; j--){
      ye -=elms2[j];
      if (ep[xe] >= ye)
	break;
    }
    sep[i] = j;
  }
}
