#define         INITIAL           1e20
#define         CALCS              100
#define         C1                   2
#define         INTERVAL             4
#define         MINSEGS              8
#define         OFF                  0
#define         ON                   1

/* LBS */
struct  SegmentData {
                int      segs;
                int      *elms;
                float    *lower;
                float    *upper;
	};

struct	LbsData {
                int     seq_length;
                struct  SegmentData segd[CALCS];
        };

struct  EnvelopeData {
                int      *begin;
                int      *end;
	};

struct  ElementData {
                int      *elms1;
                int      *elms2;
	};

struct  WarpData {
                struct EnvelopeData  seg_env[CALCS];
                struct ElementData   ed[CALCS];
	};

struct	EsortData {
                float    diff;
                int      pos;
	};

/* LBS */
float   lbs(
struct  LbsData  *lbsd1,
struct  LbsData  *lbsd2,
struct  WarpData  *warpd,
float   *lbs_buffer,
int     calc,
float   thdist
);
float   lbs2(
struct  LbsData  *lbsd1,
struct  LbsData  *lbsd2,
struct  WarpData  *warpd,
float   *lbs_buffer,
int     calc,
float   thdist
);
void    getpaa(
float   *code,
struct  LbsData  *lbsd,
int     calc
);
void    creseg(
float  *code,
struct  LbsData    *lbsd,
struct  EsortData  *esd,
int     length,
int     calc,
int     segs
);
int setcalcs(
int length
);
void setsegs(
int *appsegs, 
int length,
int calcs
);
void setsegenv(
struct  WarpData  *warpd,
int     *sp,
int     *ep,
int     segs1,
int     segs2,
int     len1,
int     len2,
int     calc
);
void    getelm(
int     *elms,
int     length,
int     segs
);
